#!/bin/perl -w
use strict;
use warnings;

sub help{
	if(grep {$_ eq "-h"} @ARGV){
		print "##############################################################################################################\n";
		print "This script can be used to prepare segments.table file used in collinear_detection.sh \n";
		print "n-way[2way-n].segments.table: select the multiplicon segments that include the determined species subgroups \n";
		print "Usage: perl Step2.pl segments.txt reference_genome subgroup_of_species_index > n-way[2way-n].segments.table \n";
		print "Input: segments.txt \n";
		print "Output: n-way[2way-n].segments.table as 7 columns including (1)segmentID;(2)multipliconID;(3)species;(4)scaffold;(5)start_anchorID;(6)end_anchorID;(7)order\n";
		print "###############################################################################################################\n";
		}
	}

&help();

#########################################################################
# Step2 in Collinear_detection.sh : select n-way colliear segments	
#########################################################################

my($segments,$ref_spec, @speciesID)=@ARGV;
&segment_select($segments,$ref_spec, @speciesID);



sub segment_select{
	(my $file,my $ref_spec, my @species)=@_;
	my @all_species=(2..15);
	my @other_species=();
	#### prepare the other species not included in @species
	foreach my $a(@all_species){
		if ($a ~~ @species){
		}else{
		push @other_species, $a;
		}
	}
	open IN,$file;
	my %m_hash;#key1:multipliconID, key2:order; value: segments line
	my %c_hash;#key:multipliconID, value: multi_segments lines
	my @m;###collect the segments_ID including Cucumber
	while (<IN>){
		chomp($_);
		my @all=split /\s+/, $_;
		my $mid=$all[1];
		my $order=$all[6];
		$m_hash{$mid}{$order}="$_\n";
		}
	close IN;

	###Traversal the hash
	for my $m(keys%m_hash) {
		my $subhash=$m_hash{$m};
    	for my $o(keys%$subhash){
			if ($m_hash{$m}{$o}=~/$ref_spec/){
				push @m, $m;
				} 
			}
		}


	###collect the cucumber multi_segments lines
	foreach my $j(@m){
		my $subhash=$m_hash{$j};
		foreach my $o(keys%$subhash){
			if (!exists $c_hash{$j}){
 				$c_hash{$j}=$m_hash{$j}{$o};
				}else {
				$c_hash{$j}=$c_hash{$j}.$m_hash{$j}{$o};
				}
			}
		}
		
	#####################################################################################################################
	#	select the species included in the segment and the other species not included
	#	shift:	spec numID:  
	#			2:Cucu-melo; 3: Water-melo; 4: Malus-dome; 5: Glyc-max; 6: Popu-tr; 7: Citrus-si; 
	#			8: Brass-ra; 9: Arab-th; 10: Arab-ly; 11: Viti-vi; 12: Sola-tu; 13: Seta-ti; 14: Brach-dis; 15: Oryza-brach                  
	#####################################################################################################################
	my %spec_hash=('2'=>'Cucu-me', '3'=>'Water-melo', '4'=> 'Malus-dome', '5'=> 'Glyc-max', '6'=>'Popu-tr', '7'=> 'Citrus','8'=>'Brass-ra','9'=>'Arab-th','10'=>'Arab-ly','11'=>'Viti-vi','12'=>'Sola-tu','13'=>'Seta-ti','14'=>'Brach','15'=>'Oryza-brach');
	foreach my $k(keys%c_hash){
		my $index=0;
		my $no_index=0;
		foreach my $s(@species){
			if ($c_hash{$k}=~/$spec_hash{$s}/m){
				$index++;
				}
   			}
		foreach my $o(@other_species){
			if ($c_hash{$k}=~/$spec_hash{$o}/m){
				$no_index++;
				}
			}
			####: if contain the input species num and not contain the other species
			if (($index == @species) and ($no_index == 0)){
				print "$c_hash{$k}";
				}
		}
	}




