#!/bin/perl -w
use strict;
use warnings;
use File::Path;


sub help{
        if(grep {$_ eq "-h"} @ARGV){
				print "##############################################################################################################\n";
				print "	This script can be used to obtain segments.gff3 used in collinear_detection.sh as Step3 \n";
				print "	n-way[2way-n]_segments.gff3: Collect the start and end information from MAAs.table and segments.table \n";
				print "	Usage: perl Step3.pl n-way[2way-n]_segments.table MAAs.table > n-way[2way-n].segments.gff3 \n";
				print "	Input: n-way[2way-n]_segments.table, MAAs.table \n";
				print "	Output: n-way[2way-n].segments.gff3 \n";
				print "	output with scaffold\tADHore\tcoline\tStart\tEnd\.\tstrand\tspec\tAnnotation \n";
				print "###############################################################################################################\n";
				}
		}

&help();









######################
#Step3: segment2gff3 #
######################

my ($segments_table, $MAAs_table)=@ARGV;

### prepare the MAAs.gffs
&block2gff3($MAAs_table, "MAAs_gff3_dir");



### Collect the segments start and end information according to MAAs

&segment2gff3($segments_table,"MAAs_gff3_dir");




sub block2gff3{
(my $file, my $out)=@_;
open IN, $file;
unless (-e $out){
		system("mkdir $out");
		open OUT, ">>$out/MAAs.gff3";
		while (<IN>){
			my @all=split /\t/, $_;
			print OUT "$all[2]\t\.\tblock\t$all[3]\t$all[4]\t$all[1]\t$all[5]\t\.\tID\=$all[0]\n";
			}
		}
close IN;
close OUT;
}






sub segment2gff3{
############################
#Segments to its gff3      #
#perl segmentfile block_gff3/#
############################
#print "scaffold\tADHore\tcoline\tStart\tEnd\.\tStrand\tspec\tAnnotation\n";
(my $file, my $gff_dir)=@_;
my %gff;# key: MAAsID  value: lines
   opendir DIR, $gff_dir;
   my @dir=readdir DIR;
   closedir DIR;
   foreach my $f(@dir){
   if ($f=~/gff3/){
   open IN, "$gff_dir/$f";
   while (<IN>){
   chomp($_);
   my @all=split /\t/, $_;
   (my $id)=($all[8]=~/ID\=(\d+)/);
   $gff{"$all[5]\.$id"}=$_;
   }
   close IN;
   }
   }
##: annotate the segments
   open IN, $file;
   while(<IN>){
   my @all=split /\t/, $_;
   my $start_id=$all[4];
   my $end_id=$all[5];
   (my $scaffold)=(split /\t/, $gff{$start_id})[0];
   (my $strand)=(split /\t/, $gff{$start_id})[6];
   my @s_line=split /\t/,$gff{$start_id};my @e_line=split /\t/,$gff{$end_id};
   print "$scaffold\tADHore\tcoline\t$s_line[3]\t$e_line[4]\t\.\t$strand\t$all[2]\tmultipliconID\=$all[1];segmentID\=$all[0]\n";
   }
   close IN
}
















